diff -Naur tomato119/tomato/release/src/router/www/bwm-hist.js tomato121/tomato/release/src/router/www/bwm-hist.js
--- tomato119/tomato/release/src/router/www/bwm-hist.js	2008-04-21 05:21:42.000000000 +1000
+++ tomato121/tomato/release/src/router/www/bwm-hist.js	2008-07-27 01:23:38.000000000 +1000
@@ -45,3 +45,53 @@
 		W('<div class="note-warning">The rstats program is not responding or is busy. Try reloading after a few seconds.</div>');
 	}
 }
+
+/*
+
+0	yyyy-mm-dd
+1	mm-dd-yy
+2	mmm, dd, yyyy
+3	dd.mm.yyyy
+
+*/
+
+var dateFormat = -1;
+
+function ymText(yr, mo)
+{
+	switch (dateFormat) {
+	case 1:
+		return (mo + 1).pad(2) + '-' + yr;
+	case 2:
+		return months[mo] + ' ' + yr;
+	case 3:
+		return (mo + 1).pad(2) + '.' + yr;
+	}
+	return yr + '-' + (mo + 1).pad(2);
+}
+
+function ymdText(yr, mo, da)
+{
+	switch (dateFormat) {
+	case 1:
+		return (mo + 1) + '-' + da.pad(2) + '-' + yr;
+	case 2:
+		return months[mo] + ' ' + da + ', ' + yr;
+	case 3:
+		return da.pad(2) + '.' + (mo + 1).pad(2) + '.' + yr;
+	}
+	return yr + '-' + (mo + 1).pad(2) + '-' + da.pad(2);
+}
+
+function changeDate(e, c)
+{
+	dateFormat = e.value * 1;
+	cookie.set(c, e.value, 31);
+	redraw();
+}
+
+function initDate(c)
+{
+	dateFormat = fixInt(cookie.get(c), 0, 3, 0)
+	E('dafm').value = dateFormat;
+}
diff -Naur tomato119/tomato/release/src/router/www/bwm-monthly.asp tomato121/tomato/release/src/router/www/bwm-monthly.asp
--- tomato119/tomato/release/src/router/www/bwm-monthly.asp	2008-04-21 05:21:42.000000000 +1000
+++ tomato121/tomato/release/src/router/www/bwm-monthly.asp	2008-07-27 01:23:38.000000000 +1000
@@ -38,7 +38,7 @@
 
 function save()
 {
-	cookie.set('monthly', scale, 14);
+	cookie.set('monthly', scale, 31);
 }
 
 function redraw()
@@ -60,7 +60,7 @@
 		yr = (((h[0] >> 16) & 0xFF) + 1900);
 		mo = ((h[0] >>> 8) & 0xFF);
 
-		grid += makeRow(((rows & 1) ? 'odd' : 'even'), months[mo] + ' ' + yr, rescale(h[1]), rescale(h[2]), rescale(h[1] + h[2]));
+		grid += makeRow(((rows & 1) ? 'odd' : 'even'), ymText(yr, mo), rescale(h[1]), rescale(h[2]), rescale(h[1] + h[2]));
 		++rows;
 	}
 
@@ -79,6 +79,7 @@
 		}
 	}
 
+	initDate('ym');
 	monthly_history.sort(cmpHist);
 	redraw();
 }
@@ -101,6 +102,7 @@
 <div class='section-title'>WAN Bandwidth - Monthly</div>
 <div id='bwm-monthly-grid' style='float:left'></div>
 <div style="float:right;text-align:right">
+<b>Date</b> <select onchange='changeDate(this, "ym")' id='dafm'><option value=0>yyyy-mm</option><option value=1>mm-yyyy</option><option value=2>mmm yyyy</option><option value=3>mm.yyyy</option></select><br>
 <b>Scale</b> <select onchange='changeScale(this)' id='scale'><option value=0>KB</option><option value=1>MB</option><option value=2 selected>GB</option></select><br>
 <br>
 &raquo; <a href="admin-bwm.asp">Configure</a>
diff -Naur tomato119/tomato/release/src/router/www/bwm-weekly.asp tomato121/tomato/release/src/router/www/bwm-weekly.asp
--- tomato119/tomato/release/src/router/www/bwm-weekly.asp	2008-04-21 05:21:42.000000000 +1000
+++ tomato121/tomato/release/src/router/www/bwm-weekly.asp	2008-07-27 01:23:39.000000000 +1000
@@ -43,7 +43,7 @@
 
 function save()
 {
-	cookie.set('weekly', scale + ',' + startwk + ',' + summary, 14);
+	cookie.set('weekly', scale + ',' + startwk + ',' + summary, 31);
 }
 
 function changeStart(e)
@@ -129,7 +129,7 @@
 		tick = d.getTime();
 		diff = lastSplit - tick;
 
-		ds = months[mo] + ' ' + da + ', ' + yr + ' <small>(' + weeksShort[wk] + ')</small>';
+		ds = ymdText(yr, mo, da) + ' <small>(' + weeksShort[wk] + ')</small>';
 
 /*	REMOVE-BEGIN
 
@@ -163,7 +163,7 @@
 			if (summary) {
 				if (i > 0) {
 					grid += makeRow(((rows & 1) ? 'odd' : 'even'), 
-						dbeg + '<br>' + dend, rescale(dl), rescale(ul), rescale(dl + ul));
+						dend + '<br>' + dbeg, rescale(dl), rescale(ul), rescale(dl + ul));
 					++rows;
 					++gn;
 				}
@@ -220,6 +220,7 @@
 		}
 	}
 
+	initDate('ymd');
 	daily_history.sort(cmpHist);
 	redraw();
 }
@@ -243,6 +244,7 @@
 <div id='bwm-weekly-grid' style='float:left'></div>
 <div style="float:right;text-align:right">
 <b>Show</b> <select onchange='changeMode(this)' id='shmode'><option value=1 selected>Summary<option value=0>Full</select><br>
+<b>Date</b> <select onchange='changeDate(this, "ymd")' id='dafm'><option value=0>yyyy-mm-dd</option><option value=1>mm-dd-yyyy</option><option value=2>mmm dd, yyyy</option><option value=3>dd.mm.yyyy</option></select><br>
 <b>Start</b> <select onchange='changeStart(this)' id='startwk'><option value=0 selected>Sun<option value=1>Mon<option value=2>Tue<option value=3>Wed<option value=4>Thu<option value=5>Fri<option value=6>Sat</select><br>
 <b>Scale</b> <select onchange='changeScale(this)' id='scale'><option value=0>KB</option><option value=1>MB</option><option value=2 selected>GB</option></select><br>
 <br>
diff -Naur tomato119/tomato/release/src/router/www/restrict-edit.asp tomato121/tomato/release/src/router/www/restrict-edit.asp
--- tomato119/tomato/release/src/router/www/restrict-edit.asp	2008-04-21 05:21:44.000000000 +1000
+++ tomato121/tomato/release/src/router/www/restrict-edit.asp	2008-07-27 01:23:40.000000000 +1000
@@ -44,7 +44,7 @@
 
 textarea {
 	width: 99%;
-	height: 8em;
+	height: 20em;
 }
 </style>
 
@@ -239,7 +239,7 @@
 	
 	e = E('_f_block_http');
 	e.value = e.value.replace(/[|"']/g, ' ');
-	if (!v_length(e, quiet, 0, 2048)) return 0;
+	if (!v_length(e, quiet, 0, 2048 - 16)) return 0;
 
 	e = E('_f_desc');
 	e.value = e.value.replace(/\|/g, '_');
@@ -332,7 +332,7 @@
 	data.push(E('_f_desc').value);
 	data = data.join('|');
 	
-	if (data.length > 2048) {
+	if (data.length >= 2048) {
 		alert('This rule is too big. Please reduce by ' + (data.length - 2048) + ' characters.');
 		return;
 	}
